import java.awt.event.*;
import java.awt.*;
import javax.swing.*;

/*
 * GUI (Graphical User Interface), mit einem eigenen Layout
 */
public class Startklasse implements ActionListener{
    JButton[] lichtbuttons;
    Spielfeld sf;

    JLabel lab1;
    JFrame frame;
    JTextArea textArea;

    public void zeigeFenster() {
        frame = new JFrame();
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setTitle("Null Layout");
        frame.setLayout(null); 

        sf = new Spielfeld(6);
        sf.getLampeNr(3).picHappy = "./merkel_smile.jpg";
        
        lichtbuttons = new JButton[6];
        
        lichtbuttons[0] = new JButton("");
        lichtbuttons[0].setBounds(0+50*0,10,50,50);
        lichtbuttons[0].addActionListener(this);
        lichtbuttons[0].setIcon(new ImageIcon(sf.getLampeNr(0).getPicname()));
        frame.add( lichtbuttons[0]);
        
        lichtbuttons[1] = new JButton("");
        lichtbuttons[1].setBounds(0+50*1,10,50,50);
        lichtbuttons[1].addActionListener(this);
        lichtbuttons[1].setIcon(new ImageIcon(sf.getLampeNr(1).getPicname()));
        frame.add( lichtbuttons[1]);
        
        lichtbuttons[2] = new JButton("");
        lichtbuttons[2].setBounds(0+50*2,10,50,50);
        lichtbuttons[2].addActionListener(this);
        lichtbuttons[2].setIcon(new ImageIcon(sf.getLampeNr(2).getPicname()));
        frame.add( lichtbuttons[2]);
        
        lichtbuttons[3] = new JButton("");
        lichtbuttons[3].setBounds(0+50*3,10,50,50);
        lichtbuttons[3].addActionListener(this);
        lichtbuttons[3].setIcon(new ImageIcon(sf.getLampeNr(3).getPicname()));
        frame.add( lichtbuttons[3]);
        
        lichtbuttons[4] = new JButton("");
        lichtbuttons[4].setBounds(0+50*4,10,50,50);
        lichtbuttons[4].addActionListener(this);
        lichtbuttons[4].setIcon(new ImageIcon(sf.getLampeNr(4).getPicname()));
        frame.add( lichtbuttons[4]);
        
        lichtbuttons[5] = new JButton("");
        lichtbuttons[5].setBounds(0+50*5,10,50,50);
        lichtbuttons[5].addActionListener(this);
        lichtbuttons[5].setIcon(new ImageIcon(sf.getLampeNr(5).getPicname()));
        frame.add( lichtbuttons[5]);
        
        lab1 = new JLabel("Mache alle Smiles glücklich!");
        lab1.setBounds(10,80,190,30);
        frame.add(lab1);

        frame.pack();
        frame.setSize(430,150);
        frame.setResizable(false);
        frame.setVisible( true );
    }

    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == lichtbuttons[0]) {
            // sf.schalteLampeNr(-1); nicht nötig
            sf.schalteLampeNr(1);
            // lichtbuttons[i-1].setIcon(new ImageIcon(sf.getLampeNr(i-1).getPicname())); den "-1"sten Button gibts nicht
            lichtbuttons[1].setIcon(new ImageIcon(sf.getLampeNr(1).getPicname()));
        }
        if(e.getSource() == lichtbuttons[1]) {
            sf.schalteLampeNr(0);
            sf.schalteLampeNr(2);
            lichtbuttons[0].setIcon(new ImageIcon(sf.getLampeNr(0).getPicname()));
            lichtbuttons[2].setIcon(new ImageIcon(sf.getLampeNr(2).getPicname()));
        }
        if(e.getSource() == lichtbuttons[2]) {
            sf.schalteLampeNr(1);
            sf.schalteLampeNr(3);
            lichtbuttons[1].setIcon(new ImageIcon(sf.getLampeNr(1).getPicname()));
            lichtbuttons[3].setIcon(new ImageIcon(sf.getLampeNr(3).getPicname()));
        }
        if(e.getSource() == lichtbuttons[3]) {
            sf.schalteLampeNr(2);
            sf.schalteLampeNr(4);
            lichtbuttons[2].setIcon(new ImageIcon(sf.getLampeNr(2).getPicname()));
            lichtbuttons[4].setIcon(new ImageIcon(sf.getLampeNr(4).getPicname()));
        }
        if(e.getSource() == lichtbuttons[4]) {
            sf.schalteLampeNr(3);
            sf.schalteLampeNr(5);
            lichtbuttons[3].setIcon(new ImageIcon(sf.getLampeNr(3).getPicname()));
            lichtbuttons[5].setIcon(new ImageIcon(sf.getLampeNr(5).getPicname()));
        }
        if(e.getSource() == lichtbuttons[5]) {
            sf.schalteLampeNr(4);
            // sf.schalteLampeNr(6); unnötig
            lichtbuttons[4].setIcon(new ImageIcon(sf.getLampeNr(4).getPicname()));
            // lichtbuttons[6].setIcon(new ImageIcon(sf.getLampeNr(6).getPicname())); den 6sten Button gibts nicht.
        }
            
    }

    public static void main() {
        Startklasse sk = new Startklasse();
        sk.zeigeFenster();
    }
}

// Aufgaben
// Aufgabe 0: Überlege Dir (nicht ausführen!), welche Dinge man im Programm 
//            ändern müsste, wenn es statt 6 nun 7 Buttons geben sollte.
// Aufgabe 1: Die Erstellung der 6 Licht-Buttons (in "zeigeFenster()") ist
//            unübersichtlich. Ersetze die 6 Abschnitte durch eine Schleife
// Aufgabe 2: Die Methode "ActionPerformed" ist unübersichtlich.
//            Ersetze die 6 Abschnitte durch eine Schleife
// Aufgabe 3: Gib dem Spieler einer Rückmeldung im Label, 
//            wenn der Spieler alle Lampen eingeschaltet hat.
// Aufgabe 4: Führe in der Methode "zeigeFenster" die Variable anzLampen ein,
//            so dass allein dieser Wert bestimmt, wieviele Lampen geschaltet
//            werden müssen.





