public class Spielfeld {
    private Lampe[] lampen;
    
    public Spielfeld(int anz) {
        lampen = new Lampe[anz];
        for(int i = 0; i < anz; i++) {
            lampen[i] = new Lampe();
        }        
    }
    
    public boolean alleLampenAn() {
        boolean erg = true;
        for(int i = 0; i < lampen.length; i++) {
            if(!lampen[i].isEingeschaltet()) {
                erg = false;
            }
        }
        return erg;
    }
    
    public void schalteLampeNr(int n) {
        if(n < lampen.length && n >= 0) {
            lampen[n].schalten();
        }
    }
    
    public Lampe getLampeNr(int n) {
        return lampen[n];
    }
}
